import * as cspell from './index';
export interface CSpellApplicationOptions {
    verbose?: boolean;
    debug?: boolean;
    config?: string;
    exclude?: string;
    wordsOnly?: boolean;
    unique?: boolean;
}
export interface AppError extends NodeJS.ErrnoException {
}
export interface RunResult {
    files: number;
    filesWithIssues: Set<string>;
    issues: number;
}
export declare type Issue = cspell.TextDocumentOffset;
export declare class CSpellApplication {
    readonly files: string[];
    readonly options: CSpellApplicationOptions;
    readonly log: (message?: any, ...args: any[]) => void;
    readonly info: (message?: any, ...args: any[]) => void;
    readonly debug: (message?: any, ...args: any[]) => void;
    readonly logIssue: (issue: Issue) => void;
    readonly uniqueFilter: (issue: Issue) => boolean;
    private configGlob;
    private configGlobOptions;
    private excludeGlobs;
    private excludes;
    constructor(files: string[], options: CSpellApplicationOptions, log: (message?: any, ...args: any[]) => void);
    run(): Promise<RunResult>;
    static createInit(_: CSpellApplicationOptions): Promise<void>;
    protected header(): void;
    protected isExcluded(filename: string): boolean;
}
